## akonadi 25.12.1+p24.04+vunstable+git20260205.0654

=== debian/changelog ===
akonadi (4:25.12.1+p24.04+vunstable+git20260205.0654-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 05 Feb 2026 06:54:30 +0000
