=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_TOOLS=ON \
	    -DBUILD_DESIGNERPLUGIN=ON \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DCOMPILE_WITH_UNITY_CMAKE_SUPPORT=ON \
		-DDATABASE_BACKEND=SQLITE
	    
execute_after_dh_install:
	dh_apparmor --profile-name=mariadbd_akonadi -pkpim6-akonadi
	dh_apparmor --profile-name=mysqld_akonadi -pkpim6-akonadi 
	dh_apparmor --profile-name=postgresql_akonadi -pkpim6-akonadi 
	dh_apparmor --profile-name=usr.bin.akonadiserver -pkpim6-akonadi
