## akonadi 25.12.2

=== debian/changelog ===
akonadi (4:25.12.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.2)
  * Update build deps.

 -- Rik Mills <rikmills@kde.org>  Sun, 08 Feb 2026 10:39:36 +0000

akonadi (4:25.12.1-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Jan 2026 10:54:01 +0000
