=== debian/changelog ===
akonadi (4:25.12.2+p24.04+vstable+git20260216.0237-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 16 Feb 2026 02:37:19 +0000

akonadi (4:25.12.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 06 Feb 2026 04:42:44 +0000
