## akonadi 25.12.2+p24.04+vstable+git20260219.0426

=== debian/changelog ===
akonadi (4:25.12.2+p24.04+vstable+git20260219.0426-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 19 Feb 2026 04:26:22 +0000
